#pragma once

#pragma once
#include <process.h>
#include <complex>
#include <Windows.h> 
#include <Winbase.h>
#include <stdio.h>
#include <sys/timeb.h>
#include <time.h>
#include <malloc.h>
#using <System.dll>
#using <System.Windows.Forms.dll>

#pragma pack(push, 1)

#include <devguid.h>
#include <winioctl.h>
#include <USBIOCTL.H>

extern "C"
{
   #include <setupapi.h>
   #include <hidsdi.h>
}

#pragma pack(pop)

HANDLE hidDevice;
DWORD instance;
GUID  HidGuid;
HIDP_CAPS cap;
BYTE HID_Data;
BYTE D1,D2,D3,D4,D5;
BOOL DoWork = false;

DWORD VID = 0x4400;  //define VID 
DWORD PID = 0x3300;  //define PID 
BYTE InputReportLen;

FILE *fp1;            // TXT_Filename for openFileDialog

namespace HID_TEST {

    using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;
	using namespace System::Threading;

	/// <summary>
	/// Form1 Kn
	///
	/// ĵi: pGzܧoOW١ANܧPoOҨ̾ڤҦ .resx ɮp
	///          Managed 귽sĶu㪺 'Resource File Name' ݩʡC
	///          _hAoǳ]pu
	///          NLkPoӪpaytƸ귽
	///          TʡC
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: b[Jغc禡{X
			//
		}

	protected:
		/// <summary>
		/// MϥΤ귽C
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  button1;
	protected: 

	private:
		/// <summary>
		/// ]puһݪܼơC
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// ]pu䴩һݪk - ФŨϥε{Xs边קoӤkeC
		///
		/// </summary>
		void InitializeComponent(void)
		{
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(21, 40);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(130, 46);
			this->button1->TabIndex = 0;
			this->button1->Text = L"Search HID";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(177, 141);
			this->Controls->Add(this->button1);
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->ResumeLayout(false);

		}
#pragma endregion

HANDLE GetDeviceHandle(GUID* pGuid, DWORD instance)   
{
   HDEVINFO info = SetupDiGetClassDevs(pGuid,NULL,NULL,DIGCF_PRESENT|DIGCF_INTERFACEDEVICE); //oثeHID˸mT

   if(info == INVALID_HANDLE_VALUE) //P_O_To\
   {
     fprintf(fp1,"No available for this GUID !\n");
     return NULL;
   }
  
   SP_DEVICE_INTERFACE_DATA ifdata;  //ŧiɭ
   ifdata.cbSize = sizeof(ifdata);   //ŧiɭƪjp , n]@Byte Format

   if(!SetupDiEnumDeviceInterfaces(info, NULL, pGuid, instance, &ifdata)) //C|˸m    
   {
	  fprintf(fp1,"SetupDiEnumDeviceInterfaces Error ! %dinstance ,  SHID˸m ! \n",instance);
      SetupDiDestroyDeviceInfoList(info);
      return NULL;
   }

   DWORD ReqLen;   
  
   SetupDiGetDeviceInterfaceDetail(info, &ifdata, NULL, 0, &ReqLen, NULL);  

   PSP_INTERFACE_DEVICE_DETAIL_DATA ifDetail = (PSP_INTERFACE_DEVICE_DETAIL_DATA)(new char[ReqLen]);   
  
   
   int ErrorCode2 = GetLastError(); 

   if(ifDetail==NULL)
   {
	  fprintf(fp1,"ifDetail == NULL !\n");
      SetupDiDestroyDeviceInfoList(info);
	  return NULL;
   }

   ifDetail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);

   if(!SetupDiGetDeviceInterfaceDetail(info, &ifdata, ifDetail, ReqLen, NULL, NULL))
   {   
	  fprintf(fp1,"SetupDiGetDeviceInterfaceDetail Error !\n");
      SetupDiDestroyDeviceInfoList(info);
	  delete ifDetail;
      return NULL;   
   }
	 
	   HANDLE pDevice = CreateFile(ifDetail->DevicePath,   
       GENERIC_READ | GENERIC_WRITE,    //0
       FILE_SHARE_READ | FILE_SHARE_WRITE,  
       NULL,   
       OPEN_EXISTING,   
       FILE_ATTRIBUTE_NORMAL,   
       NULL);   
  

	 int ErrorCode = GetLastError(); 
     if(ErrorCode==5)
     {
		 fprintf(fp1,"%dinstance , ErrorCode = %d , ]ŪQڵ ! ( HID = Keyboard or Mouse ) \n\n",instance,ErrorCode);
     }
	 else
	 {
		fprintf(fp1,"DevicePath = %s\n\n",ifDetail->DevicePath);
		fprintf(fp1,"instance = %d , Error Code = %d\n\n",instance,ErrorCode);
	 }

   if(pDevice==INVALID_HANDLE_VALUE)pDevice = NULL;

   delete ifDetail;   
   SetupDiDestroyDeviceInfoList(info);

   return pDevice;   
}   



private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) 
{
				  HidD_GetHidGuid(&HidGuid);  //ޤJҦ HID GUID X
	              HANDLE Info = SetupDiGetClassDevs(&HidGuid,NULL,NULL,DIGCF_PRESENT|DIGCF_DEVICEINTERFACE); //oHIDT
     
	              if(Info == INVALID_HANDLE_VALUE) //poTL , ^lA
				  return; 

	              instance = 0; //HID˸m 0 }ljM
				  fopen_s(&fp1,"HID_Data.txt","w");  //}Ҽgɾ

	              for(instance=0; instance<20; instance++)  //M20HID]
	              {   
					  hidDevice = GetDeviceHandle(&HidGuid,instance);  //oHID˸mhandle
                      //if(m_hHid == NULL)
					  //return;

					  ::HIDD_ATTRIBUTES att;
					  ::PHIDP_PREPARSED_DATA pPreData;
					  ::HIDP_CAPS Capab;

		             	  if(HidD_GetAttributes(hidDevice, &att))   
						  {		    
							    fprintf(fp1,"VID = 0x%04X , PID = 0x%04X , Version = %04X  , the %dth HID device\n\n" , att.VendorID,att.ProductID,att.VersionNumber,instance);
								
								wchar_t mString[256];
								char ch_buffer[256];
								char blank[1];
/*
							if(HidD_GetManufacturerString(hidDevice,mString,sizeof(mString)))
							{
								if(wcstombs(ch_buffer,mString,256)==-1)ch_buffer[0]=blank[0];
								fprintf(fp1,"Manufacturer : %s\n\n",ch_buffer);
							}
*/        
								if (HidD_GetPreparsedData(hidDevice, &pPreData))
								{
									if (HidP_GetCaps(pPreData, & cap ) == HIDP_STATUS_SUCCESS)
									{
										fprintf(fp1,"Usage page %d usage %d\n",Capab.Usage,Capab.Usage);
										fprintf(fp1,"InputReportByteLength %d\n",Capab.InputReportByteLength);
										fprintf(fp1,"OutputReportByteLength %d\n",Capab.OutputReportByteLength);
										fprintf(fp1,"FeatureReportByteLength %d\n",Capab.FeatureReportByteLength);
										fprintf(fp1,"NumberLinkCollectionNodes %d\n\n", Capab.NumberLinkCollectionNodes);
                                        fprintf(fp1,"NumberInputButtonCaps %d\n", Capab.NumberInputButtonCaps);
                                        fprintf(fp1,"NumberInputValueCaps %d\n", Capab.NumberInputValueCaps);
                                        fprintf(fp1,"NumberOutputButtonCaps %d\n", Capab.NumberOutputButtonCaps);
                                        fprintf(fp1,"NumberOutputValueCaps %d\n", Capab.NumberOutputValueCaps);
                                        fprintf(fp1,"NumberFeatureButtonCaps %d\n", Capab.NumberFeatureButtonCaps);
                                        fprintf(fp1,"NumberFeatureValueCaps %d\n\n\n\n\n", Capab.NumberFeatureValueCaps);
									}
								}
								if(att.VendorID == VID && att.ProductID == PID && DoWork == false)
								{
									
								}
						  }
						  else fprintf(fp1,"LkŪ˸mT !\n\n\n\n\n");
				  }

}

};
}

